{################################################################################}
{# Copyright (c) 2022-2024 Bayerische Motoren Werke Aktiengesellschaft (BMW AG) #}
{#                                                                              #}
{# This program and the accompanying materials are made available under the     #}
{# terms of the Eclipse Public License 2.0 which is available at                #}
{# http://www.eclipse.org/legal/epl-2.0.                                        #}
{#                                                                              #}
{# SPDX-License-Identifier: EPL-2.0                                             #}
{################################################################################}
{% extends "baseclass.h.j2" %}

{#############################################################################}

{% block includes %}
    {% block includes_special %}{% endblock %}
    #include "Storyboard/GenericAction/{{ name }}_impl.h"
    #include <openScenarioLib/generated/v1_3/api/ApiClassInterfacesV1_3.h>
    #include <agnostic_behavior_tree/action_node.h>
    #include "Utils/EntityBroker.h"
    #include <cassert>
    {% for dep in node.dependencies %}
    #include {{dep.include}}
    {% endfor %}
{% endblock %}

{#############################################################################}

{% block nodetype %}
ActionNode
{% endblock %}

{#############################################################################}

{% block onInit %}
void onInit() override{};
{% endblock %}

{#############################################################################}

{% block tick %}
    yase::NodeStatus tick() override
    {
        assert(impl_);
        const auto is_finished = impl_->Step();
        return is_finished ? yase::NodeStatus::kSuccess : yase::NodeStatus::kRunning;
    };
{% endblock %}

{#############################################################################}

{% block blackboard_getter %}
    {% for var in node.dependencies %}
        {{var.type}} {{util.local(var)}} = blackboard.get<{{var.type}}>("{{util.tag(var)}}");
    {% endfor %}
    {% block blackboard_getter_special %}{% endblock %}
    const EntityBroker::Ptr entityBroker = blackboard.get<EntityBroker::Ptr>("EntityBroker");

    impl_ = std::make_unique<{{ose_namespace}}::{{node.umlClass.name}}>(
            {{ose_namespace}}::{{node.umlClass.name}}::Values{
                {% block implementation_values_special %}{% endblock %}
                entityBroker->GetEntities(),
                {{ node.values | join(',\n') }}
            },
            {{ose_namespace}}::{{node.umlClass.name}}::Interfaces{
                {% for var in node.blackboard_getter %}
                    {{util.local(var)}}{{',' if not loop.last else ''}}
                {% endfor %}
            });
{% endblock %}

{#############################################################################}

{% block member_definitions %}
std::unique_ptr<{{ose_namespace}}::{{node.umlClass.name}}> impl_{nullptr};
{% endblock %}